﻿Imports Leap
Imports System.Windows.Ink
Imports Microsoft.Maps.MapControl.WPF
Imports System.Net.Http

Class MainWindow
    Private Declare Function SetCursorPos Lib "user32" (x As Integer, y As Integer) As Boolean
    Private Declare Function apimouse_event Lib "user32" Alias "mouse_event" (ByVal dwFlags As Int32, ByVal dx As Int32, ByVal dy As Int32, ByVal cButtons As Int32, ByVal dwExtraInfo As Int32) As Boolean
    Private Const MOUSEEVENTF_LEFTDOWN = &H2
    Private Const MOUSEEVENTF_LEFTUP = &H4
    'Private Const MOUSEEVENTF_MOVE = &H1
    Private leap As New Controller
    Private touchIndicator As New DrawingAttributes
    Private touchPoint As StylusPoint

    Private xmldoc As XElement
    Private AddressList As New List(Of String)

    Private tx As Double
    Private ty As Double
    Private x As Integer
    Private y As Integer

    Private Index As Integer

    Private windowWidth As Double = 1920
    Private windowHeight As Double = 1080

    Private FingersCount As Integer = 0
    Private selectAddress As String
    Private myAddressLatitude As String
    Private myAddressLongitude As String

    Private Sub MainWindow_Loaded(sender As Object, e As RoutedEventArgs) Handles Me.Loaded

        xmldoc = XElement.Load("address.xml")

        For Each result In From c In xmldoc.Descendants("住所名") Select c
            AddressList.Add(result.Value)
        Next
        ListBox1.ItemsSource = AddressList

        AddHandler CompositionTarget.Rendering, AddressOf Update
        touchIndicator.Width = 15
        touchIndicator.Height = 15

        touchIndicator.StylusTip = StylusTip.Ellipse

    End Sub

    Private Sub Update(sender As Object, e As EventArgs)
        paintCanvas.Strokes.Clear()
        windowWidth = Me.Width
        windowHeight = Me.Height

        Dim frame As Leap.Frame = leap.Frame
        Dim interactionBox As InteractionBox = leap.Frame.InteractionBox

        For Each Pointable As Pointable In leap.Frame.Pointables
            Dim normalizedPosition As Leap.Vector = interactionBox.NormalizePoint(Pointable.StabilizedTipPosition)

            tx = normalizedPosition.x * windowWidth
            ty = windowHeight - normalizedPosition.y * windowHeight

            touchPoint = New StylusPoint(tx, ty)

            Dim tips As New StylusPointCollection(New StylusPoint() {touchPoint})
            Dim touchStroke As New Stroke(tips, touchIndicator)
            paintCanvas.Strokes.Add(touchStroke)

            'ホーバー
            If Pointable.TouchDistance > 0 AndAlso Pointable.TouchZone <> Global.Leap.Pointable.Zone.ZONENONE Then
                touchIndicator.Color = Colors.Blue
                x = touchPoint.X
                y = touchPoint.Y

                apimouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0)
                FingersCount = leap.Frame.Fingers.Count
                'タッチ
            ElseIf Pointable.TouchDistance <= 0 Then

                touchIndicator.Color = Colors.Red

                If FingersCount = 1 Then

                    SetCursorPos(x, y)
                    apimouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0)
                End If

                'タッチ対象外
            Else
                touchIndicator.Color = Colors.Gold
            End If
        Next
    End Sub

    Private Sub ListBox1_SelectionChanged(sender As Object, e As SelectionChangedEventArgs) Handles ListBox1.SelectionChanged
        Dim client As New HttpClient
        Dim myPin As New Pushpin
        selectAddress = xmldoc.Descendants("住所名")(ListBox1.SelectedIndex).Value
        Dim addressUri = String.Format("http://www.geocoding.jp/api/?v=1.1&q={0}", selectAddress)
        Dim myResponse = client.GetStringAsync(New Uri(addressUri, UriKind.Absolute))
        Dim myContent = myResponse.Result
        Dim doc = XElement.Parse(myContent)
        myAddressLatitude = doc.Descendants("coordinate").Elements("lat").Value
        myAddressLongitude = doc.Descendants("coordinate").Elements("lng").Value

        Dim myLabel As New Label
        With myLabel
            .Content = selectAddress
            .Foreground = New SolidColorBrush(Colors.Navy)
            .Background = New SolidColorBrush(Colors.Beige)
            .FontSize = 20

        End With

        Dim myLocation As New Location
        myLocation.Latitude = myAddressLatitude
        myLocation.Longitude = myAddressLongitude
        myPin.Location = New Location(myAddressLatitude, myAddressLongitude)
        MapLayer.SetPosition(myLabel, myLocation)

        myMap.SetView(myLocation, 16)
        myMap.Children.Add(myPin)
        myMap.Children.Add(myLabel)
    End Sub

    Private Sub plusButton_Click(sender As Object, e As RoutedEventArgs) Handles plusButton.Click
        myMap.ZoomLevel += 1
    End Sub

    Private Sub minusButton_Click(sender As Object, e As RoutedEventArgs) Handles minusButton.Click
        myMap.ZoomLevel -= 1
    End Sub


End Class

